(function (_, Kotlin) {
  'use strict';
  var Kind_CLASS = Kotlin.Kind.CLASS;
  var Kind_INTERFACE = Kotlin.Kind.INTERFACE;
  var Kind_OBJECT = Kotlin.Kind.OBJECT;
  var toByte = Kotlin.toByte;
  MidiMessage$InvalidMessage.prototype = Object.create(MidiMessage.prototype);
  MidiMessage$InvalidMessage.prototype.constructor = MidiMessage$InvalidMessage;
  MidiMessage$NoteOffMessage.prototype = Object.create(MidiMessage.prototype);
  MidiMessage$NoteOffMessage.prototype.constructor = MidiMessage$NoteOffMessage;
  MidiMessage$NoteOnMessage.prototype = Object.create(MidiMessage.prototype);
  MidiMessage$NoteOnMessage.prototype.constructor = MidiMessage$NoteOnMessage;
  MidiMessage$AfterTouchMessage.prototype = Object.create(MidiMessage.prototype);
  MidiMessage$AfterTouchMessage.prototype.constructor = MidiMessage$AfterTouchMessage;
  MidiMessage$ControlChangeMessage.prototype = Object.create(MidiMessage.prototype);
  MidiMessage$ControlChangeMessage.prototype.constructor = MidiMessage$ControlChangeMessage;
  MidiMessage$ProgramChangeMessage.prototype = Object.create(MidiMessage.prototype);
  MidiMessage$ProgramChangeMessage.prototype.constructor = MidiMessage$ProgramChangeMessage;
  MidiMessage$ChannelPressureMessage.prototype = Object.create(MidiMessage.prototype);
  MidiMessage$ChannelPressureMessage.prototype.constructor = MidiMessage$ChannelPressureMessage;
  MidiMessage$PitchBendMessage.prototype = Object.create(MidiMessage.prototype);
  MidiMessage$PitchBendMessage.prototype.constructor = MidiMessage$PitchBendMessage;
  MidiMessage$SystemCommonMessage.prototype = Object.create(MidiMessage.prototype);
  MidiMessage$SystemCommonMessage.prototype.constructor = MidiMessage$SystemCommonMessage;
  function MpeParser() {
  }
  MpeParser.prototype.parse = function (byteArray) {
    return parseAsMidiMessage(byteArray);
  };
  MpeParser.prototype.on = function (messageType, callback) {
  };
  MpeParser.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'MpeParser',
    interfaces: []
  };
  function doThing() {
  }
  function Channeled() {
  }
  Channeled.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'Channeled',
    interfaces: []
  };
  var NOTE_OFF_CODE;
  var NOTE_ON_CODE;
  var AFTER_TOUCH_CODE;
  var CONTROL_CHANGE_CODE;
  var PROGRAM_CHANGE_CODE;
  var CHANNEL_PRESSURE_CODE;
  var PITCH_BEND_CODE;
  var SYSTEM_COMMON_CODE;
  function parseAsMidiMessage(bytes) {
    var tmp$;
    if (bytes.length === 0) {
      return MidiMessage$InvalidMessage_getInstance();
    }
    var firstByte = bytes[0];
    var code = bitSubstring(firstByte, 0, 3);
    var channel = bitSubstring(firstByte, 4, 7);
    switch (code) {
      case 9:
        if (bytes[2] === 0) {
          tmp$ = new MidiMessage$NoteOffMessage(channel, bytes[1], bytes[2]);
        }
         else {
          tmp$ = new MidiMessage$NoteOnMessage(channel, bytes[1], bytes[2]);
        }

        break;
      case 8:
        tmp$ = new MidiMessage$NoteOffMessage(channel, bytes[1], bytes[2]);
        break;
      case 10:
        tmp$ = new MidiMessage$AfterTouchMessage(channel, bytes[1], bytes[2]);
        break;
      case 11:
        tmp$ = new MidiMessage$ControlChangeMessage(channel, bytes[1], bytes[2]);
        break;
      case 12:
        tmp$ = new MidiMessage$ProgramChangeMessage(channel, bytes[1]);
        break;
      case 13:
        tmp$ = new MidiMessage$ChannelPressureMessage(channel, bytes[1]);
        break;
      case 14:
        tmp$ = new MidiMessage$PitchBendMessage(channel, bytes[1], bytes[2]);
        break;
      case 15:
        tmp$ = new MidiMessage$SystemCommonMessage(bytes);
        break;
      default:tmp$ = MidiMessage$InvalidMessage_getInstance();
        break;
    }
    return tmp$;
  }
  function MidiMessage() {
  }
  function MidiMessage$InvalidMessage() {
    MidiMessage$InvalidMessage_instance = this;
    MidiMessage.call(this);
  }
  MidiMessage$InvalidMessage.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'InvalidMessage',
    interfaces: [MidiMessage]
  };
  var MidiMessage$InvalidMessage_instance = null;
  function MidiMessage$InvalidMessage_getInstance() {
    if (MidiMessage$InvalidMessage_instance === null) {
      new MidiMessage$InvalidMessage();
    }
    return MidiMessage$InvalidMessage_instance;
  }
  function MidiMessage$NoteOffMessage(channel, note, velocity) {
    MidiMessage.call(this);
    this.channel_ebmpb7$_0 = channel;
    this.note = note;
    this.velocity = velocity;
  }
  Object.defineProperty(MidiMessage$NoteOffMessage.prototype, 'channel', {
    get: function () {
      return this.channel_ebmpb7$_0;
    }
  });
  MidiMessage$NoteOffMessage.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'NoteOffMessage',
    interfaces: [Channeled, MidiMessage]
  };
  MidiMessage$NoteOffMessage.prototype.component1 = function () {
    return this.channel;
  };
  MidiMessage$NoteOffMessage.prototype.component2 = function () {
    return this.note;
  };
  MidiMessage$NoteOffMessage.prototype.component3 = function () {
    return this.velocity;
  };
  MidiMessage$NoteOffMessage.prototype.copy_d9r5kp$ = function (channel, note, velocity) {
    return new MidiMessage$NoteOffMessage(channel === void 0 ? this.channel : channel, note === void 0 ? this.note : note, velocity === void 0 ? this.velocity : velocity);
  };
  MidiMessage$NoteOffMessage.prototype.toString = function () {
    return 'NoteOffMessage(channel=' + Kotlin.toString(this.channel) + (', note=' + Kotlin.toString(this.note)) + (', velocity=' + Kotlin.toString(this.velocity)) + ')';
  };
  MidiMessage$NoteOffMessage.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.channel) | 0;
    result = result * 31 + Kotlin.hashCode(this.note) | 0;
    result = result * 31 + Kotlin.hashCode(this.velocity) | 0;
    return result;
  };
  MidiMessage$NoteOffMessage.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.channel, other.channel) && Kotlin.equals(this.note, other.note) && Kotlin.equals(this.velocity, other.velocity)))));
  };
  function MidiMessage$NoteOnMessage(channel, note, velocity) {
    MidiMessage.call(this);
    this.channel_vahylj$_0 = channel;
    this.note = note;
    this.velocity = velocity;
  }
  Object.defineProperty(MidiMessage$NoteOnMessage.prototype, 'channel', {
    get: function () {
      return this.channel_vahylj$_0;
    }
  });
  MidiMessage$NoteOnMessage.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'NoteOnMessage',
    interfaces: [Channeled, MidiMessage]
  };
  MidiMessage$NoteOnMessage.prototype.component1 = function () {
    return this.channel;
  };
  MidiMessage$NoteOnMessage.prototype.component2 = function () {
    return this.note;
  };
  MidiMessage$NoteOnMessage.prototype.component3 = function () {
    return this.velocity;
  };
  MidiMessage$NoteOnMessage.prototype.copy_d9r5kp$ = function (channel, note, velocity) {
    return new MidiMessage$NoteOnMessage(channel === void 0 ? this.channel : channel, note === void 0 ? this.note : note, velocity === void 0 ? this.velocity : velocity);
  };
  MidiMessage$NoteOnMessage.prototype.toString = function () {
    return 'NoteOnMessage(channel=' + Kotlin.toString(this.channel) + (', note=' + Kotlin.toString(this.note)) + (', velocity=' + Kotlin.toString(this.velocity)) + ')';
  };
  MidiMessage$NoteOnMessage.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.channel) | 0;
    result = result * 31 + Kotlin.hashCode(this.note) | 0;
    result = result * 31 + Kotlin.hashCode(this.velocity) | 0;
    return result;
  };
  MidiMessage$NoteOnMessage.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.channel, other.channel) && Kotlin.equals(this.note, other.note) && Kotlin.equals(this.velocity, other.velocity)))));
  };
  function MidiMessage$AfterTouchMessage(channel, note, pressure) {
    MidiMessage.call(this);
    this.channel_w1cnk7$_0 = channel;
    this.note = note;
    this.pressure = pressure;
  }
  Object.defineProperty(MidiMessage$AfterTouchMessage.prototype, 'channel', {
    get: function () {
      return this.channel_w1cnk7$_0;
    }
  });
  MidiMessage$AfterTouchMessage.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'AfterTouchMessage',
    interfaces: [Channeled, MidiMessage]
  };
  MidiMessage$AfterTouchMessage.prototype.component1 = function () {
    return this.channel;
  };
  MidiMessage$AfterTouchMessage.prototype.component2 = function () {
    return this.note;
  };
  MidiMessage$AfterTouchMessage.prototype.component3 = function () {
    return this.pressure;
  };
  MidiMessage$AfterTouchMessage.prototype.copy_d9r5kp$ = function (channel, note, pressure) {
    return new MidiMessage$AfterTouchMessage(channel === void 0 ? this.channel : channel, note === void 0 ? this.note : note, pressure === void 0 ? this.pressure : pressure);
  };
  MidiMessage$AfterTouchMessage.prototype.toString = function () {
    return 'AfterTouchMessage(channel=' + Kotlin.toString(this.channel) + (', note=' + Kotlin.toString(this.note)) + (', pressure=' + Kotlin.toString(this.pressure)) + ')';
  };
  MidiMessage$AfterTouchMessage.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.channel) | 0;
    result = result * 31 + Kotlin.hashCode(this.note) | 0;
    result = result * 31 + Kotlin.hashCode(this.pressure) | 0;
    return result;
  };
  MidiMessage$AfterTouchMessage.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.channel, other.channel) && Kotlin.equals(this.note, other.note) && Kotlin.equals(this.pressure, other.pressure)))));
  };
  function MidiMessage$ControlChangeMessage(channel, controller, value) {
    MidiMessage.call(this);
    this.channel_y9ogd$_0 = channel;
    this.controller = controller;
    this.value = value;
  }
  Object.defineProperty(MidiMessage$ControlChangeMessage.prototype, 'channel', {
    get: function () {
      return this.channel_y9ogd$_0;
    }
  });
  MidiMessage$ControlChangeMessage.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'ControlChangeMessage',
    interfaces: [Channeled, MidiMessage]
  };
  MidiMessage$ControlChangeMessage.prototype.component1 = function () {
    return this.channel;
  };
  MidiMessage$ControlChangeMessage.prototype.component2 = function () {
    return this.controller;
  };
  MidiMessage$ControlChangeMessage.prototype.component3 = function () {
    return this.value;
  };
  MidiMessage$ControlChangeMessage.prototype.copy_d9r5kp$ = function (channel, controller, value) {
    return new MidiMessage$ControlChangeMessage(channel === void 0 ? this.channel : channel, controller === void 0 ? this.controller : controller, value === void 0 ? this.value : value);
  };
  MidiMessage$ControlChangeMessage.prototype.toString = function () {
    return 'ControlChangeMessage(channel=' + Kotlin.toString(this.channel) + (', controller=' + Kotlin.toString(this.controller)) + (', value=' + Kotlin.toString(this.value)) + ')';
  };
  MidiMessage$ControlChangeMessage.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.channel) | 0;
    result = result * 31 + Kotlin.hashCode(this.controller) | 0;
    result = result * 31 + Kotlin.hashCode(this.value) | 0;
    return result;
  };
  MidiMessage$ControlChangeMessage.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.channel, other.channel) && Kotlin.equals(this.controller, other.controller) && Kotlin.equals(this.value, other.value)))));
  };
  function MidiMessage$ProgramChangeMessage(channel, programNumber) {
    MidiMessage.call(this);
    this.channel_wc19uu$_0 = channel;
    this.programNumber = programNumber;
  }
  Object.defineProperty(MidiMessage$ProgramChangeMessage.prototype, 'channel', {
    get: function () {
      return this.channel_wc19uu$_0;
    }
  });
  MidiMessage$ProgramChangeMessage.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'ProgramChangeMessage',
    interfaces: [Channeled, MidiMessage]
  };
  MidiMessage$ProgramChangeMessage.prototype.component1 = function () {
    return this.channel;
  };
  MidiMessage$ProgramChangeMessage.prototype.component2 = function () {
    return this.programNumber;
  };
  MidiMessage$ProgramChangeMessage.prototype.copy_5gdoe6$ = function (channel, programNumber) {
    return new MidiMessage$ProgramChangeMessage(channel === void 0 ? this.channel : channel, programNumber === void 0 ? this.programNumber : programNumber);
  };
  MidiMessage$ProgramChangeMessage.prototype.toString = function () {
    return 'ProgramChangeMessage(channel=' + Kotlin.toString(this.channel) + (', programNumber=' + Kotlin.toString(this.programNumber)) + ')';
  };
  MidiMessage$ProgramChangeMessage.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.channel) | 0;
    result = result * 31 + Kotlin.hashCode(this.programNumber) | 0;
    return result;
  };
  MidiMessage$ProgramChangeMessage.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.channel, other.channel) && Kotlin.equals(this.programNumber, other.programNumber)))));
  };
  function MidiMessage$ChannelPressureMessage(channel, value) {
    MidiMessage.call(this);
    this.channel_45v75a$_0 = channel;
    this.value = value;
  }
  Object.defineProperty(MidiMessage$ChannelPressureMessage.prototype, 'channel', {
    get: function () {
      return this.channel_45v75a$_0;
    }
  });
  MidiMessage$ChannelPressureMessage.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'ChannelPressureMessage',
    interfaces: [Channeled, MidiMessage]
  };
  MidiMessage$ChannelPressureMessage.prototype.component1 = function () {
    return this.channel;
  };
  MidiMessage$ChannelPressureMessage.prototype.component2 = function () {
    return this.value;
  };
  MidiMessage$ChannelPressureMessage.prototype.copy_5gdoe6$ = function (channel, value) {
    return new MidiMessage$ChannelPressureMessage(channel === void 0 ? this.channel : channel, value === void 0 ? this.value : value);
  };
  MidiMessage$ChannelPressureMessage.prototype.toString = function () {
    return 'ChannelPressureMessage(channel=' + Kotlin.toString(this.channel) + (', value=' + Kotlin.toString(this.value)) + ')';
  };
  MidiMessage$ChannelPressureMessage.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.channel) | 0;
    result = result * 31 + Kotlin.hashCode(this.value) | 0;
    return result;
  };
  MidiMessage$ChannelPressureMessage.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.channel, other.channel) && Kotlin.equals(this.value, other.value)))));
  };
  function MidiMessage$PitchBendMessage(channel, lsb, msb) {
    MidiMessage.call(this);
    this.channel_gn7gnz$_0 = channel;
    this.lsb = lsb;
    this.msb = msb;
  }
  Object.defineProperty(MidiMessage$PitchBendMessage.prototype, 'channel', {
    get: function () {
      return this.channel_gn7gnz$_0;
    }
  });
  MidiMessage$PitchBendMessage.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'PitchBendMessage',
    interfaces: [Channeled, MidiMessage]
  };
  MidiMessage$PitchBendMessage.prototype.component1 = function () {
    return this.channel;
  };
  MidiMessage$PitchBendMessage.prototype.component2 = function () {
    return this.lsb;
  };
  MidiMessage$PitchBendMessage.prototype.component3 = function () {
    return this.msb;
  };
  MidiMessage$PitchBendMessage.prototype.copy_d9r5kp$ = function (channel, lsb, msb) {
    return new MidiMessage$PitchBendMessage(channel === void 0 ? this.channel : channel, lsb === void 0 ? this.lsb : lsb, msb === void 0 ? this.msb : msb);
  };
  MidiMessage$PitchBendMessage.prototype.toString = function () {
    return 'PitchBendMessage(channel=' + Kotlin.toString(this.channel) + (', lsb=' + Kotlin.toString(this.lsb)) + (', msb=' + Kotlin.toString(this.msb)) + ')';
  };
  MidiMessage$PitchBendMessage.prototype.hashCode = function () {
    var result = 0;
    result = result * 31 + Kotlin.hashCode(this.channel) | 0;
    result = result * 31 + Kotlin.hashCode(this.lsb) | 0;
    result = result * 31 + Kotlin.hashCode(this.msb) | 0;
    return result;
  };
  MidiMessage$PitchBendMessage.prototype.equals = function (other) {
    return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && (Kotlin.equals(this.channel, other.channel) && Kotlin.equals(this.lsb, other.lsb) && Kotlin.equals(this.msb, other.msb)))));
  };
  function MidiMessage$SystemCommonMessage(rawByteArray) {
    MidiMessage.call(this);
    this.rawByteArray = rawByteArray;
  }
  MidiMessage$SystemCommonMessage.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'SystemCommonMessage',
    interfaces: [MidiMessage]
  };
  MidiMessage.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'MidiMessage',
    interfaces: []
  };
  function bitSubstring($receiver, from, to) {
    var bitsToDrop = 7 - to;
    var shifted = $receiver >>> bitsToDrop;
    var bitsToKeep = to - from + 1 | 0;
    return toByte(shifted & 255 >>> 8 - bitsToKeep);
  }
  _.MpeParser = MpeParser;
  _.doThing = doThing;
  var package$io = _.io || (_.io = {});
  var package$intrepid = package$io.intrepid || (package$io.intrepid = {});
  var package$midi = package$intrepid.midi || (package$intrepid.midi = {});
  package$midi.Channeled = Channeled;
  Object.defineProperty(package$midi, 'NOTE_OFF_CODE', {
    get: function () {
      return NOTE_OFF_CODE;
    }
  });
  Object.defineProperty(package$midi, 'NOTE_ON_CODE', {
    get: function () {
      return NOTE_ON_CODE;
    }
  });
  Object.defineProperty(package$midi, 'AFTER_TOUCH_CODE', {
    get: function () {
      return AFTER_TOUCH_CODE;
    }
  });
  Object.defineProperty(package$midi, 'CONTROL_CHANGE_CODE', {
    get: function () {
      return CONTROL_CHANGE_CODE;
    }
  });
  Object.defineProperty(package$midi, 'PROGRAM_CHANGE_CODE', {
    get: function () {
      return PROGRAM_CHANGE_CODE;
    }
  });
  Object.defineProperty(package$midi, 'CHANNEL_PRESSURE_CODE', {
    get: function () {
      return CHANNEL_PRESSURE_CODE;
    }
  });
  Object.defineProperty(package$midi, 'PITCH_BEND_CODE', {
    get: function () {
      return PITCH_BEND_CODE;
    }
  });
  Object.defineProperty(package$midi, 'SYSTEM_COMMON_CODE', {
    get: function () {
      return SYSTEM_COMMON_CODE;
    }
  });
  package$midi.parseAsMidiMessage_fqrh44$ = parseAsMidiMessage;
  Object.defineProperty(MidiMessage, 'InvalidMessage', {
    get: MidiMessage$InvalidMessage_getInstance
  });
  MidiMessage.NoteOffMessage = MidiMessage$NoteOffMessage;
  MidiMessage.NoteOnMessage = MidiMessage$NoteOnMessage;
  MidiMessage.AfterTouchMessage = MidiMessage$AfterTouchMessage;
  MidiMessage.ControlChangeMessage = MidiMessage$ControlChangeMessage;
  MidiMessage.ProgramChangeMessage = MidiMessage$ProgramChangeMessage;
  MidiMessage.ChannelPressureMessage = MidiMessage$ChannelPressureMessage;
  MidiMessage.PitchBendMessage = MidiMessage$PitchBendMessage;
  MidiMessage.SystemCommonMessage = MidiMessage$SystemCommonMessage;
  package$midi.MidiMessage = MidiMessage;
  var package$util = package$intrepid.util || (package$intrepid.util = {});
  package$util.bitSubstring_glfpss$ = bitSubstring;
  NOTE_OFF_CODE = 8;
  NOTE_ON_CODE = 9;
  AFTER_TOUCH_CODE = 10;
  CONTROL_CHANGE_CODE = 11;
  PROGRAM_CHANGE_CODE = 12;
  CHANNEL_PRESSURE_CODE = 13;
  PITCH_BEND_CODE = 14;
  SYSTEM_COMMON_CODE = 15;
  Kotlin.defineModule('mpe-js', _);
  return _;
}(module.exports, require('kotlin')));
